
/*C*

________________________________________________________________

        xite_png.h
        $Id: xite_png.h,v 1.7 2004/07/01 12:10:45 svein Exp $
        Copyright 2004, Blab, UiO
        Image processing lab, Department of Informatics
        University of Oslo
        E-mail: blab@ifi.uio.no
________________________________________________________________
  
  Permission to use, copy, modify and distribute this software and its
  documentation for any purpose and without fee is hereby granted, 
  provided that this copyright notice appear in all copies and that 
  both that copyright notice and this permission notice appear in supporting
  documentation and that the name of B-lab, Department of Informatics or
  University of Oslo not be used in advertising or publicity pertaining 
  to distribution of the software without specific, written prior permission.

  B-LAB DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL B-LAB
  BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
  WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
  OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN 
  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 

*/

#ifndef _PNG_H_
#define _PNG_H_

_XITE_CPLUSPLUS_BEGIN

#include <xite/biff.h>
#include <xite/color.h>
#include <png.h>

#define XITE_PNG_GRAYSCALE 0
#define XITE_PNG_PALETTE   1
#define XITE_PNG_RGB       2

#define XITE_PNG_PALETTE_SIZE 256

extern _XITE_PNG_WIN_DLL int biff2png8  _XITE_PARAMS(( IBAND band, png_structp png_ptr, png_infop info_ptr, int compression_method, int interlace_method ));
extern _XITE_PNG_WIN_DLL int biff2png16  _XITE_PARAMS(( IUS_BAND band, png_structp png_ptr, png_infop info_ptr, int compression_method, int interlace_method ));
extern _XITE_PNG_WIN_DLL int biff2png8p  _XITE_PARAMS(( IBAND band, png_structp png_ptr, png_infop info_ptr, Color_tab coltab, int colLen, int compression_method, int interlace_method ));
extern _XITE_PNG_WIN_DLL int biff2png8c  _XITE_PARAMS(( IMAGE img, png_structp png_ptr, png_infop info_ptr, int compression_method, int interlace_method ));
extern _XITE_PNG_WIN_DLL int biff2png16c  _XITE_PARAMS(( IUS_IMAGE img, png_structp png_ptr, png_infop info_ptr, int compression_method, int interlace_method ));
extern _XITE_PNG_WIN_DLL int biff2png  _XITE_PARAMS(( IMAGE img, png_structp png_ptr, png_infop info_ptr, int format, Color_tab coltab, int colLen, int compression_method, int interlace_method ));
extern _XITE_PNG_WIN_DLL int png2biff8  _XITE_PARAMS(( png_structp png_ptr, png_infop info_ptr, IBAND *band ));
extern _XITE_PNG_WIN_DLL int png2biff16  _XITE_PARAMS(( png_structp png_ptr, png_infop info_ptr, IUS_BAND *band ));
extern _XITE_PNG_WIN_DLL int png2biff8p  _XITE_PARAMS(( png_structp png_ptr, png_infop info_ptr, IBAND *band, Color_tab coltab, int *colLen ));
extern _XITE_PNG_WIN_DLL int png2biff8c  _XITE_PARAMS(( png_structp png_ptr, png_infop info_ptr, IMAGE *img ));
extern _XITE_PNG_WIN_DLL int png2biff16c  _XITE_PARAMS(( png_structp png_ptr, png_infop info_ptr, IMAGE *img ));
extern _XITE_PNG_WIN_DLL int png2biff  _XITE_PARAMS(( png_structp png_ptr, png_infop info_ptr, IMAGE *img, Color_tab coltab, int *colLen ));

_XITE_CPLUSPLUS_END

#endif /* _PNG_H_ */
